package ir.ac.ut.ece.naeem;
/*
 * Created on Mar 1, 2004
 */

/**
 * This is some kind of list that its elements are sorted in ascending order.
 * @author Naeem
 * @see List
 * @version 1.0
 * @since insert, min, max, search, delete
 */
public class SortedList extends List {

	/**
	 * @see List#insert(Comparable)
	 */
	public void insert(Comparable key) {
		if( head == null) {
			head = new Item( key , null);
			return;
		}
		
		DItem temp = find( key);
		Item found = temp.first;
		Item previous = temp.second;
		
		if( found != null && found.key.compareTo( key) < 0) {
			previous = found;
			found = found.item;
		}
		
		if( previous != null)
			previous.item = new Item( key, found);
		else
			head = new Item( key, head);
	}

	/**
	 * @see List#min()
	 */
	public Item min() {
		return head;
	}

	/**
	 * @see List#max()
	 */
	public Item max() {
		Item previous = null;
		Item index = head;
		
		while( index != null) {
			previous = index;
			index = index.item;
		}

		return previous;
	}

	/**
	 * @see List#find(Comparable)
	 */
	protected DItem find(Comparable key) {
		if( head == null)
			return new DItem( null, null);
		
		Item index = head;
		Item previous = null;
		
		while( index != null && index.key.compareTo( key) < 0) {
			previous = index;
			index = index.item;
		}
		
		return new DItem( index, previous);
	}

	public static void main(String[] args) {
		SortedList mylist = new SortedList();
		
		mylist.insert( new Integer(12));
		mylist.insert( new Integer(13));
		mylist.insert( new Integer(21));
		mylist.insert( new Integer(7));
		mylist.insert( new Integer(19));
		mylist.insert( new Integer(12));
//		mylist.insert( new Float(12));
		
		System.out.println( mylist.head);
		System.out.println( mylist.min());
		System.out.println( mylist.max());
		System.out.println( mylist.search( new Integer( 13)));
		System.out.println( mylist.search( new Integer( 3)));
		
		try {
		mylist.delete( new Integer( 7));
		}catch( ItemNotFound e){
			System.out.println( "Not Found!!");
		}
		
		System.out.println( mylist.head);
		System.out.println( mylist.min());
		System.out.println( mylist.max());
		System.out.println( mylist.search( new Integer( 13)));
		System.out.println( mylist.search( new Integer( 3)));
		
		try {
		mylist.delete( new Integer( 13));
		}catch( ItemNotFound e){
			System.out.println( "Not Found!!");
		}
		
		System.out.println( mylist.head);
		System.out.println( mylist.min());
		System.out.println( mylist.max());
		System.out.println( mylist.search( new Integer( 13)));
		System.out.println( mylist.search( new Integer( 3)));
		
		try {
		mylist.delete( new Integer( 93));
		}catch( ItemNotFound e){
			System.out.println( "Not Found!!");
		}
		
		System.out.println( mylist.head);
		System.out.println( mylist.min());
		System.out.println( mylist.max());
		System.out.println( mylist.search( new Integer( 13)));
		System.out.println( mylist.search( new Integer( 3)));

	}
}
